# Animate moving a circle to the position clicked by the user 5 times
# by CSCI 111, 09.26.2012

from graphics import *
from time import sleep

CIRCLE_RADIUS = 50

STEPS = 50

win = GraphWin("Circle Shift", 500, 500)

# Give instructions to the user
anchorPoint = Point(win.getWidth()/2, 10)
instruction = Text(anchorPoint, "Click where you want your circle to go.")
instruction.draw(win)

# create the initial circle in the center of the window and draw it
midPoint = Point(win.getWidth()/2, win.getHeight()/2)
circle = Circle( midPoint, CIRCLE_RADIUS)
circle.draw(win)

for n in range(5):
    # get the user input--the mouse click
    point2 = win.getMouse()
        
    # compute the change in X and the change in Y
    changeInX = point2.getX() - circle.getCenter().getX()
    changeInY =  point2.getY() - circle.getCenter().getY()
    
    # figure out the increments of change in x and y
    incrementX = changeInX/STEPS
    incrementY = changeInY/STEPS
    
    # animate the moving of the circle, in STEPS increments
    for s in range(STEPS):
        circle.move(incrementX, incrementY)
        sleep(.05)
    
# update the user's instructions
instruction.setText("Click to close")

win.getMouse()
win.close()
