# Simulate Pick 4 lottery game - selecting ping pong balls at random
# Modified to count number of correctly chosen numbers
# By CSCI111

from random import *
import sys

# define constants that are easy to change so that our
# program is flexible
NUM_PICKS = 4
MIN_VALUE = 0
MAX_VALUE = 9

NUMFORMAT="#" * NUM_PICKS

# get the user's input, as a string to maintain the four digits
userNumber = input("What is your pick (format: " + NUMFORMAT + ")? ")

# check if the user's number is valid
# Specifically, check if the user's number has the correct number of digits
if len(userNumber) != NUM_PICKS:
    print("Error: incorrect number of digits")
    print("You need", NUM_PICKS, "digits")
    sys.exit()
# TODO: check if the user's number is only numbers

winningNum = ""
numMatches = 0

for whichPick in range(NUM_PICKS):
    chosen = randint(MIN_VALUE, MAX_VALUE)
    # concatenate the chosen number to the winning number
    winningNum = winningNum + str(chosen)
    if str(chosen) == userNumber[whichPick]: 
        # alternative, use winningNum[whichPick] instead of str(chosen)
        numMatches = numMatches + 1
        
print("The winning Pick 4 number is", winningNum)
print()

# determine if the user won
if userNumber == winningNum:
    print("Congratulations!  You won!")
elif numMatches >= 1:
    print("You matched", numMatches, "numbers.  Collect your prize.")
else:    
    print("Sorry.  You shouldn't be wasting your money anyway.")
    
    
    
    
    
    
    
    
    
