# Wheel of Fortune
# By Sara Sprenkle

PROMPT="Enter a letter or try to solve the puzzle: "
TITLE_WIDTH=50

# print out a nice header
print("*"*TITLE_WIDTH)
print("WHEEL".center(TITLE_WIDTH))
print("OF".center(TITLE_WIDTH))
print("FORTUNE!".center(TITLE_WIDTH))
print("*"*TITLE_WIDTH )

categoryNames = ["movies", "songs", "famous_pairs"]

for num in range(len(categoryNames)):
    print("Press", (num+1), "for", categoryNames[num])
    
# input from user about which puzzle file to use
selection = eval(input("Which category do you choose? "))
        
# change categoryName to file names
puzzleFile = open("data/" + categoryNames[selection-1] + ".txt", "r")

puzzleid = 0

# each line in the puzzleFile is a puzzle
# go through them all ...
for puzzle in puzzleFile: 
    puzzle = puzzle.strip()
    
    puzzleid+=1

    # Display the current puzzle.  
    # All the alphabetical characters are displayed as underscores.
    displayedPuzzle = ""
    for char in puzzle:
        if char.isalpha():
            displayedPuzzle += "_"
        else:
            displayedPuzzle += char

    print("Puzzle %d: %s" % (puzzleid, displayedPuzzle))

    print()
    
    # how many guesses it took to get it right
    numGuesses = 1
    
    guess = input(PROMPT)
    
    while guess.lower() != puzzle.lower() :
        if len(guess) == 1 and guess.isalpha(): 
            numOccurences = puzzle.count(guess) + puzzle.count(guess.swapcase())
            if numOccurences > 0:
                print ("There are", numOccurences, guess + "'s", "in the phrase")
                # fill in puzzle
                updatedpuzzle=""
                for pos in range(len(puzzle)):
                    if puzzle[pos] == guess or puzzle[pos] == guess.swapcase():
                        updatedpuzzle += puzzle[pos]
                    else:
                        updatedpuzzle += displayedPuzzle[pos]
                displayedPuzzle = updatedpuzzle
                
                print ("\nThe puzzle is", displayedPuzzle)
            else:
                print ("Sorry, there are no", guess + "'s", "in the word")
        elif len(guess) != 1:
            # assumes that the user tried to solve the puzzle but got it wrong.
            print ("\tSorry, that is not correct.")
        else:
            print ("\tError: You must guess a letter.")
        
        print()
        guess = input(PROMPT)
        numGuesses += 1
            
    print ("Congratulations!  You solved the puzzle in", numGuesses, "guesses")

puzzleFile.close()

print("We're out of puzzles!  Thanks for playing!")
