# Simulate Pick 4 lottery game - selecting ping pong balls at random
# Modified to figure out if the user entered the winning number
# By CSCI111

from random import *
import sys

# define constants that are easy to change so that our
# program is flexible
NUM_PICKS = 4
MIN_VALUE = 0
MAX_VALUE = 9

NUMFORMAT="#" * NUM_PICKS

def main():

    # get the user's input, as a string to maintain the four digits
    userNumber = input("What is your pick (format: " + NUMFORMAT + ")? ")
    
    # check if user number is valid
    # Specifically, check if the user's number has four digits
    if len(userNumber) != NUM_PICKS:
        print("Error")
        sys.exit()
    # TODO: check if user number is all numbers
    
    winningNum = generateWinningNum()
    
    print("The winning Pick 4 number is", winningNum)
    print()
    
    # determine if the user won
    if userNumber == winningNum:
        print("Congratulations!  You won!")
    else:
        print("Sorry.  You shouldn't be wasting your money anyway.")
    
    
def generateWinningNum():
    """
    Generates and returns the winning number for the Pick4 game
    """
    # accumulate the winning number as a string
    winningNum = ""
    
    for whichPick in range(NUM_PICKS):
        chosen = randint(MIN_VALUE, MAX_VALUE)
        # concatenate the chosen number to the winning number
        winningNum = winningNum + str(chosen)
    return winningNum
    
main()
