# Converts a binary number into a decimal
# Modify to verify that the inputted number is valid.
# By CSCI111

import sys

def main():
    # Read in the binary number as a string -- why?
    num = input("Enter the binary #: ")
    
    # --------- Validate the user input ----------
    if not isBinary(num):
        print(num, "is not a valid binary number.  Please try again.")
        sys.exit()
        
    decVal = binaryToDecimal(num)
    
    print("The decimal value for", num, "is", decVal)


def binaryToDecimal(binnum):
    """
    Converts the binary number to a decimal number
    Precondition: binary, a string that is a binary number
    Postcondition: returns the decimal value of the binary number
    """
    # accumulate the decimal value in this variable
    decVal = 0
    
    # go through the positions in the string
    for pos in range(len(binnum)):
        # num[pos] is a string; need to convert to an int
        bit = int(binnum[pos])
        # calculate which "place" the current bit is at
        place = 2**(len(binnum)-pos-1)
        # add to the decimal value
        decVal += place * bit
    return decVal

    
def isBinary(candidate):
    """
    Precondition: candidate is a string
    Postcondition: returns True iff candidate is a valid binary string
    """
    # check that it has all digits (no letters)
    if not candidate.isdigit():
        return False
     
    # Make sure that the inputted number only contains 0s and 1s
    for digit in candidate:
        if digit != "0" and digit != "1":
            return False
    return True

def testIsBinary():
    """
    Test the isBinary function.
    Displays the correctness or incorrectness of the function.
    Does not return anything.
    """
    
    testBinaryTrue = ["0", "1", "1000"]
    
    for test in testBinaryTrue:
        result = isBinary(test)
        if result:
            print(test, "successfully identified as binary")
        else:
            print("**ERROR! **", test, "considered not binary")
    
    testBinaryFalse = ["blue", "47", "11.1"]
    
    for test in testBinaryFalse:
        result = isBinary(test)
        if not result:
            print(test, "successfully identified as not binary")
        else:
            print("**ERROR! **", test, "considered binary")

def testBinaryToDecimal():
    """Test the binaryToDecimal function.  
        Displays the correctness or incorrectness of the function.
        Nothing is returned."""
        
    inputs = ["0", "1", "1000", "10", "0011"]
    expectedResults = [0, 1, 8, 2, 3]
    for index in range(len(inputs)):
        testInput = inputs[index]
        expectedResult = expectedResults[index]
        actualResult = binaryToDecimal(testInput)
        if actualResult != expectedResult:
            print("**ERROR! **", testInput, "should be", expectedResult)
            print("Instead, got", actualResult)
        else:
            print("Success on binary to decimal for", testInput, "-->", actualResult)
            
testIsBinary()
testBinaryToDecimal()            
