# Simulate Pick 4 lottery game - selecting ping pong balls at random
# Modified to figure out if the user entered the winning number
# NEW: Updated to demonstrate a default parameter to a function.
# By CSCI111

from random import *
import sys

# define constants that are easy to change so that our
# program is flexible
NUM_PICKS = 4
MIN_VALUE = 0
MAX_VALUE = 9

NUMFORMAT="####"

def main():

    pickedNum = input("What is your pick? (Format: " + NUMFORMAT + ") ")
    
    ######  handle bad input ######
    error = False
    errorMessage = "Error:\n"
    
    # Check that user enters a string that contains only numbers
    if not pickedNum.isdigit():
        errorMessage += "\tYour number must contain only numbers\n"
        error = True
    
    # User enters a number that is not four digits long
    if len(pickedNum) != 4:
        errorMessage += "\tYour number must contain four numbers"
        error = True
        
    if error:
        print(errorMessage)
        sys.exit()
    
    winningNum = generateWinningNum()
    
    print("The winning Pick 4 lottery number is ", winningNum)
    print()
    
    if winningNum == pickedNum:
        print("Congratulations!  You are very lucky and rich!")
        print("We should be friends!")
    else:
        print("Sorry, you lost.")
    
def generateWinningNum(numNums=NUM_PICKS):
    """
    generates a winning number based on constants defined for ...
    returns a string of random numbers of length numNums; 
    default numNums is NUM_PICKS
    """
    # Generate the random number; accumulator design pattern
    winNum = "" # start the winning number as the empty string
    
    for i in range(numNums):
        # generate a random number
        # add the random number to the previous random number
        winNum += str(randint(MIN_VALUE,MAX_VALUE))
        
    return winNum
    
main()
