# Given a file of the form <lastname> <year>
# creates a mapping between the year and the number of students
# in that year.
# by CSCI 111

FILENAME="data/years.dat"

# open the data file for reading
yearsFile = open(FILENAME, "r")

# create an accumulator dictionary
yearToNumberOfStudents = {}

# iterate through the lines of the file
for line in yearsFile:
    # split the line
    # the list created has the last name as the first item
    # and the second item in the list is the year
    lineList = line.split()
    lastname = lineList[0]  # --> no longer need the last name
    year = int(lineList[1])
    
    # find out if there was a previous count
    oldCount = yearToNumberOfStudents.get(year)
    
    # there was no mapping in the dictionary yet
    if oldCount is None:
        # just found a student
        yearToNumberOfStudents[year] = 1
    else:
        yearToNumberOfStudents[year] = oldCount + 1
        
    # Alternative solution:
    # if year in yearToNumberOfStudents:
    #     yearToNumberOfStudents[year]+=1
    # else:
    #     yearToNumberOfStudents[year] = 1
    
yearsFile.close()

print("The number of students enrolled in CSCI111 for each class year:")
print("%4s %5s" % ("Year", "Count"))
print("-"*4, "-"*5)
for year in sorted(yearToNumberOfStudents):
    count = yearToNumberOfStudents[year]
    print("%4d %5d" % (year, count))
    
    
    
